include masm32rt.inc
.data?
	hInstance		HINSTANCE	?
.code
main proc
LOCAL msg:MSG
LOCAL wc:WNDCLASSEX

	mov hInstance,rv(GetModuleHandle,0)
	mov wc.hInstance,eax
	mov wc.cbSize,SIZEOF wc
	mov wc.style,CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc,WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,SIZEOF HDC + SIZEOF HWND + 2*(SIZEOF DWORD)
	mov wc.lpszClassName,chr$("WinClass32")
	mov wc.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wc.hIconSm,eax
	mov wc.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	mov wc.lpszMenuName,0
	mov wc.hbrBackground,0
	invoke RegisterClassEx,ADDR wc
	
	mov edi,rv(CreateWindowEx,0,wc.lpszClassName,"Main Window",WS_VISIBLE or WS_POPUP,100,100,200,200,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,0,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg		
	.endw

	exit
	
main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL rect:RECT
LOCAL ps:PAINTSTRUCT
LOCAL hdc:HDC
LOCAL nx:DWORD
LOCAL ny:DWORD
LOCAL pt:POINT
LOCAL _size:_SIZE

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,0
	.elseif uMsg == WM_DESTROY
		invoke DeleteDC,rv(GetWindowLong,hWnd,0)
	.elseif uMsg == WM_CREATE
		mov edi,rv(GetDC,rv(GetDesktopWindow))
		mov hdc,rv(CreateCompatibleDC,edi)
		mov nx,rv(GetSystemMetrics,SM_CXSCREEN)
		mov ny,rv(GetSystemMetrics,SM_CYSCREEN)
		invoke DeleteObject,rv(SelectObject,hdc,rv(CreateCompatibleBitmap,edi,nx,ny))
		invoke ReleaseDC,rv(GetDesktopWindow),edi
		invoke GetWindowRect,hWnd,ADDR rect
		
		mov edx,rect.right
		mov ecx,rect.bottom
		sub edx,rect.left
		sub ecx,rect.top
		mov ebx,rv(CreateEllipticRgn,0,0,edx,ecx)

		mov esi,rv(CreateSolidBrush,0ffffffh)

		invoke FillRgn,hdc,ebx,esi
		invoke FrameRgn,hdc,ebx,rv(GetStockObject,BLACK_BRUSH),1,1
		invoke SetWindowRgn,hWnd,ebx,0
		invoke DeleteObject,esi
		invoke SetWindowLong,hWnd,0,hdc
		
		mov edi,rv(GetClassLong,hWnd,GCL_HMODULE)
		mov edx,rect.right
		sub edx,rect.left
		mov ecx,15
		shr edx,1
		push edx
		lea edx,[edx-10]
		fn CreateWindowEx,0,"Button","X",BS_CENTER or WS_CHILD or WS_VISIBLE,edx,ecx,20,20,hWnd,0,edi,0
		invoke SetWindowLong,hWnd,SIZEOF HDC,eax
		fn GetTextExtentPoint32,hdc,"drag me",7,ADDR _size
		mov ecx,_size.x
		shr ecx,1
		pop eax
		sub eax,ecx
		mov ecx,eax
		mov edx,rect.bottom
		sub edx,rect.top
		shr edx,1
		mov eax,_size.y
		shr eax,1
		sub edx,eax
		fn TextOut,hdc,ecx,edx,"drag me",7
	.elseif uMsg == WM_COMMAND
		mov ebx,rv(GetWindowLong,hWnd,SIZEOF HDC)
		.if ebx == lParam
			.if WORD ptr wParam+2 == BN_CLICKED
				invoke DestroyWindow,hWnd
				invoke PostQuitMessage,0
			.endif
		.endif
	.elseif uMsg == WM_LBUTTONDOWN
		invoke GetCursorPos,ADDR pt
		mov edx,pt.y
		shl edx,16
		or edx,pt.x
		invoke SetWindowLong,hWnd,SIZEOF HDC + SIZEOF HWND + SIZEOF DWORD,edx
		invoke SetWindowLong,hWnd,SIZEOF HDC + SIZEOF HWND,1
		invoke SetCapture,hWnd
	.elseif uMsg == WM_LBUTTONUP
		invoke SetWindowLong,hWnd,SIZEOF HDC + SIZEOF HWND,0
		invoke ReleaseCapture
	.elseif uMsg == WM_MOUSEMOVE
		mov ebx,rv(GetWindowLong,hWnd,SIZEOF HDC + SIZEOF HWND)
		.if ebx
			mov ebx,rv(GetWindowLong,hWnd,SIZEOF HDC + SIZEOF HWND + SIZEOF DWORD)
			invoke GetWindowRect,hWnd,ADDR rect
			invoke GetCursorPos,ADDR pt
			movzx ecx,bx
			mov edx,ebx
			shr edx,16
			mov eax,ecx
			mov ecx,pt.x
			sub ecx,eax
			mov eax,edx
			mov edx,pt.y
			sub edx,eax
			add rect.left,ecx
			add rect.top,edx
			invoke SetWindowPos,hWnd,0,rect.left,rect.top,0,0,SWP_NOSIZE or SWP_NOZORDER
			mov edx,pt.y
			shl edx,16
			or edx,pt.x
			invoke SetWindowLong,hWnd,SIZEOF HDC + SIZEOF HWND + SIZEOF DWORD,edx
		.endif
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov hdc,rv(GetWindowLong,hWnd,0)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,hdc,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
	
WndProc endp

end main